/* This file was automatically generated by CasADi.
   The CasADi copyright holders make no ownership claim of its contents. */
#ifdef __cplusplus
extern "C" {
#endif

/* How to prefix internal symbols */
#ifdef CASADI_CODEGEN_PREFIX
  #define CASADI_NAMESPACE_CONCAT(NS, ID) _CASADI_NAMESPACE_CONCAT(NS, ID)
  #define _CASADI_NAMESPACE_CONCAT(NS, ID) NS ## ID
  #define CASADI_PREFIX(ID) CASADI_NAMESPACE_CONCAT(CODEGEN_PREFIX, ID)
#else
  #define CASADI_PREFIX(ID) foo_ ## ID
#endif

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <osqp/osqp.h>

#ifndef casadi_real
#define casadi_real double
#endif

#ifndef casadi_int
#define casadi_int long long int
#endif

#ifndef CASADI_MAX_NUM_THREADS
#define CASADI_MAX_NUM_THREADS 1
#endif

/* Add prefix to internal symbols */
#define casadi_clear CASADI_PREFIX(clear)
#define casadi_copy CASADI_PREFIX(copy)
#define casadi_f0 CASADI_PREFIX(f0)
#define casadi_f0_alloc_mem CASADI_PREFIX(f0_alloc_mem)
#define casadi_f0_init_mem CASADI_PREFIX(f0_init_mem)
#define casadi_f0_mem CASADI_PREFIX(f0_mem)
#define casadi_f0_mem_counter CASADI_PREFIX(f0_mem_counter)
#define casadi_f0_unused_stack CASADI_PREFIX(f0_unused_stack)
#define casadi_f0_unused_stack_counter CASADI_PREFIX(f0_unused_stack_counter)
#define casadi_fill CASADI_PREFIX(fill)
#define casadi_s0 CASADI_PREFIX(s0)
#define casadi_s1 CASADI_PREFIX(s1)
#define casadi_s2 CASADI_PREFIX(s2)
#define casadi_s3 CASADI_PREFIX(s3)
#define casadi_s4 CASADI_PREFIX(s4)
#define casadi_s5 CASADI_PREFIX(s5)
#define casadi_s6 CASADI_PREFIX(s6)
#define casadi_s7 CASADI_PREFIX(s7)
#define casadi_s8 CASADI_PREFIX(s8)
#define casadi_tri_project CASADI_PREFIX(tri_project)

/* Symbol visibility in DLLs */
#ifndef CASADI_SYMBOL_EXPORT
  #if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
    #if defined(STATIC_LINKED)
      #define CASADI_SYMBOL_EXPORT
    #else
      #define CASADI_SYMBOL_EXPORT __declspec(dllexport)
    #endif
  #elif defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
    #define CASADI_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
  #else
    #define CASADI_SYMBOL_EXPORT
  #endif
#endif

#ifndef casadi_inf
  #define casadi_inf INFINITY
#endif

void casadi_copy(const casadi_real* x, casadi_int n, casadi_real* y) {
  casadi_int i;
  if (y) {
    if (x) {
      for (i=0; i<n; ++i) *y++ = *x++;
    } else {
      for (i=0; i<n; ++i) *y++ = 0.;
    }
  }
}

void casadi_clear(casadi_real* x, casadi_int n) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = 0;
  }
}

void casadi_fill(casadi_real* x, casadi_int n, casadi_real alpha) {
  casadi_int i;
  if (x) {
    for (i=0; i<n; ++i) *x++ = alpha;
  }
}

void casadi_tri_project(const casadi_real* x, const casadi_int* sp_x, casadi_real* y, casadi_int lower) {
  casadi_int ncol_x, j, k;
  const casadi_int *colind_x, *row_x;
  ncol_x = sp_x[1];
  colind_x = sp_x+2; row_x = sp_x + 2 + ncol_x+1;
  for (j=0; j<ncol_x; ++j) {
    for (k=colind_x[j]; k<colind_x[j+1]; ++k) {
      if (lower) {
        if (row_x[k]>=j) *y++ = x ? x[k] : 0;
      } else {
        if (row_x[k]<=j) *y++ = x ? x[k] : 0;
      }
    }
  }
}

static int casadi_f0_mem_counter = 0;
static int casadi_f0_unused_stack_counter = -1;
static int casadi_f0_unused_stack[CASADI_MAX_NUM_THREADS];
static OSQPWorkspace *casadi_f0_mem[CASADI_MAX_NUM_THREADS];

#ifndef CASADI_PRINTF
#define CASADI_PRINTF printf
#endif

static const casadi_int casadi_s0[5] = {2, 2, 0, 0, 0};
static const casadi_int casadi_s1[3] = {0, 1, 2};
static const casadi_int casadi_s2[4] = {0, 2, 1, 2};
static const casadi_int casadi_s3[3] = {0, 2, 4};
static const casadi_int *casadi_s4 = 0;
static const casadi_int casadi_s5[3] = {0, 0, 0};
static const casadi_int casadi_s6[6] = {2, 1, 0, 2, 0, 1};
static const casadi_int casadi_s7[7] = {1, 2, 0, 1, 2, 0, 0};
static const casadi_int casadi_s8[5] = {1, 1, 0, 1, 0};

/* conic:(h[2x2,0nz],g[2],a[1x2],lba,uba,lbx[2],ubx[2],x0[2],lam_x0[2],lam_a0,q[],p[])->(x[2],cost,lam_a,lam_x[2]) */
static int casadi_f0(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem) {
  OSQPWorkspace *work=casadi_f0_mem[mem];
  casadi_int i, n, offset;
  /* Set objective */
  if (arg[1]) {
    casadi_copy(arg[1], 2, w);
  } else {
    casadi_clear(w, 2);
  }
  if (osqp_update_lin_cost(work, w)) return 1;
  /* Set bounds */
  if (arg[5]) {
    casadi_copy(arg[5], 2, w);
  } else {
    casadi_fill(w, 2, -casadi_inf);
  }
  if (arg[3]) {
    casadi_copy(arg[3], 1, w+2);
  } else {
    casadi_fill(w+2, 1, -casadi_inf);
  }
  if (arg[6]) {
    casadi_copy(arg[6], 2, w+3);
  } else {
    casadi_fill(w+3, 2, casadi_inf);
  }
  if (arg[4]) {
    casadi_copy(arg[4], 1, w+5);
  } else {
    casadi_fill(w+5, 1, casadi_inf);
  }
  if (osqp_update_bounds(work, w, w+3)) return 1;
  /* Project Hessian */
  casadi_tri_project(arg[0], casadi_s0, w, 0);/* Get constraint matrix */
  offset = 0;
  for (i=0; i< 2; ++i) {
    w[0+offset] = 1;
    offset++;
    n = casadi_s1[i+1]-casadi_s1[i];
    casadi_copy(arg[2]+casadi_s1[i], n, w+offset+0);
    offset+= n;
  }
  /* Pass Hessian and constraint matrices */
  if (osqp_update_P_A(work, w, 0, 0, w+0, 0, 4)) return 1;
  if (osqp_warm_start_x(work, arg[7])) return 1;
  if (arg[8]) {
    casadi_copy(arg[8], 2, w);
  } else {
    casadi_clear(w, 2);
  }
  if (arg[9]) {
    casadi_copy(arg[9], 1, w+2);
  } else {
    casadi_clear(w+2, 1);
  }
  if (osqp_warm_start_y(work, w)) return 1;
  if (osqp_solve(work)) return 1;
  if (res[1]) casadi_copy(&work->info->obj_val, 1, res[1]);
  if (res[0]) casadi_copy(work->solution->x, 2, res[0]);
  if (res[3]) casadi_copy(work->solution->y, 2, res[3]);
  if (res[2]) casadi_copy(work->solution->y+2, 1, res[2]);
  if (work->info->status_val != OSQP_SOLVED) {
    return -1000;
  }
  return 0;
  return 0;
}

void casadi_f0_incref(void) {
}

void casadi_f0_decref(void) {
}

int casadi_f0_alloc_mem(void) {
  return casadi_f0_mem_counter++;
}

int casadi_f0_init_mem(int mem) {
  OSQPData data;
  OSQPSettings settings;
  c_int A_colind[3], A_row[4], H_colind[3], *H_row=0, i;
  casadi_real dummy[4];
  csc A, H;
  casadi_clear(dummy, 4);
  for (i=0;i<4;++i) A_row[i] = casadi_s2[i];
  for (i=0;i<3;++i) A_colind[i] = casadi_s3[i];
  for (i=0;i<3;++i) H_colind[i] = casadi_s5[i];
  A.m = 3;
  A.n = 2;
  A.nz = 4;
  A.nzmax = 4;
  A.x = dummy;
  A.i = A_row;
  A.p = A_colind;
  H.m = 2;
  H.n = 2;
  H.nz = 0;
  H.nzmax = 0;
  H.x = dummy;
  H.i = H_row;
  H.p = H_colind;
  data.n = 2;
  data.m = 3;
  data.P = &H;
  data.q = dummy;
  data.A = &A;
  data.l = dummy;
  data.u = dummy;
  osqp_set_default_settings(&settings);
  settings.rho = 0.1;
  settings.sigma = 1e-06;
  settings.scaling = 10;
  settings.adaptive_rho = 1;
  settings.adaptive_rho_interval = 0;
  settings.adaptive_rho_tolerance = 5;
  settings.max_iter = 4000;
  settings.eps_abs = 0.001;
  settings.eps_rel = 0.001;
  settings.eps_prim_inf = 0.0001;
  settings.eps_dual_inf = 0.0001;
  settings.alpha = 1.6;
  settings.delta = 1e-06;
  settings.polish = 0;
  settings.polish_refine_iter = 3;
  settings.verbose = 1;
  settings.scaled_termination = 0;
  settings.check_termination = 25;
  settings.warm_start = 0;
  casadi_f0_mem[mem] = osqp_setup(&data, &settings);
  return 0;
}

void casadi_f0_free_mem(int mem) {
  osqp_cleanup(casadi_f0_mem[mem]);
}

int casadi_f0_checkout(void) {
  int mid;
  if (casadi_f0_unused_stack_counter>=0) {
    return casadi_f0_unused_stack[casadi_f0_unused_stack_counter--];
  } else {
    if (casadi_f0_mem_counter==CASADI_MAX_NUM_THREADS) return -1;
    mid = casadi_f0_alloc_mem();
    if (mid<0) return -1;
    if(casadi_f0_init_mem(mid)) return -1;
    return mid;
  }
}

void casadi_f0_release(int mem) {
  casadi_f0_unused_stack[++casadi_f0_unused_stack_counter] = mem;
}

CASADI_SYMBOL_EXPORT int conic(const casadi_real** arg, casadi_real** res, casadi_int* iw, casadi_real* w, int mem){
  return casadi_f0(arg, res, iw, w, mem);
}

CASADI_SYMBOL_EXPORT int conic_alloc_mem(void) {
  return casadi_f0_alloc_mem();
}

CASADI_SYMBOL_EXPORT int conic_init_mem(int mem) {
  return casadi_f0_init_mem(mem);
}

CASADI_SYMBOL_EXPORT void conic_free_mem(int mem) {
  casadi_f0_free_mem(mem);
}

CASADI_SYMBOL_EXPORT int conic_checkout(void) {
  return casadi_f0_checkout();
}

CASADI_SYMBOL_EXPORT void conic_release(int mem) {
  casadi_f0_release(mem);
}

CASADI_SYMBOL_EXPORT void conic_incref(void) {
}

CASADI_SYMBOL_EXPORT void conic_decref(void) {
}

CASADI_SYMBOL_EXPORT casadi_int conic_n_in(void) { return 12;}

CASADI_SYMBOL_EXPORT casadi_int conic_n_out(void) { return 4;}

CASADI_SYMBOL_EXPORT casadi_real conic_default_in(casadi_int i) {
  switch (i) {
    case 3: return -casadi_inf;
    case 4: return casadi_inf;
    case 5: return -casadi_inf;
    case 6: return casadi_inf;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* conic_name_in(casadi_int i) {
  switch (i) {
    case 0: return "h";
    case 1: return "g";
    case 2: return "a";
    case 3: return "lba";
    case 4: return "uba";
    case 5: return "lbx";
    case 6: return "ubx";
    case 7: return "x0";
    case 8: return "lam_x0";
    case 9: return "lam_a0";
    case 10: return "q";
    case 11: return "p";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const char* conic_name_out(casadi_int i) {
  switch (i) {
    case 0: return "x";
    case 1: return "cost";
    case 2: return "lam_a";
    case 3: return "lam_x";
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* conic_sparsity_in(casadi_int i) {
  switch (i) {
    case 0: return casadi_s0;
    case 1: return casadi_s6;
    case 2: return casadi_s7;
    case 3: return casadi_s8;
    case 4: return casadi_s8;
    case 5: return casadi_s6;
    case 6: return casadi_s6;
    case 7: return casadi_s6;
    case 8: return casadi_s6;
    case 9: return casadi_s8;
    case 10: return casadi_s5;
    case 11: return casadi_s5;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT const casadi_int* conic_sparsity_out(casadi_int i) {
  switch (i) {
    case 0: return casadi_s6;
    case 1: return casadi_s8;
    case 2: return casadi_s8;
    case 3: return casadi_s6;
    default: return 0;
  }
}

CASADI_SYMBOL_EXPORT int conic_work(casadi_int *sz_arg, casadi_int* sz_res, casadi_int *sz_iw, casadi_int *sz_w) {
  if (sz_arg) *sz_arg = 12;
  if (sz_res) *sz_res = 4;
  if (sz_iw) *sz_iw = 0;
  if (sz_w) *sz_w = 6;
  return 0;
}

casadi_int main_conic(casadi_int argc, char* argv[]) {
  casadi_int j;
  casadi_real* a;
  const casadi_real* r;
  casadi_int flag;
  int mem;
  casadi_int *iw = 0;
  casadi_real w[27];
  const casadi_real* arg[12];
  casadi_real* res[4];
  arg[0] = w+0;
  arg[1] = w+0;
  arg[2] = w+2;
  arg[3] = w+4;
  arg[4] = w+5;
  arg[5] = w+6;
  arg[6] = w+8;
  arg[7] = w+10;
  arg[8] = w+12;
  arg[9] = w+14;
  arg[10] = w+15;
  arg[11] = w+15;
  res[0] = w+15;
  res[1] = w+17;
  res[2] = w+18;
  res[3] = w+19;
  a = w;
  for (j=0; j<15; ++j) if (scanf("%lg", a++)<=0) return 2;
  mem = conic_checkout();
  flag = conic(arg, res, iw, w+21, mem);
  conic_release(mem);
  if (flag) return flag;
  r = w+15;
  for (j=0; j<6; ++j) CASADI_PRINTF("%g ", *r++);
  CASADI_PRINTF("\n");
  return 0;
}


int main(int argc, char* argv[]) {
  if (argc<2) {
    /* name error */
  } else if (strcmp(argv[1], "conic")==0) {
    return main_conic(argc-2, argv+2);
  }
  fprintf(stderr, "First input should be a command string. Possible values: 'conic'\nNote: you may use function.generate_input to create a command string.\n");
  return 1;
}
#ifdef __cplusplus
} /* extern "C" */
#endif
